/* Tabela SERIEENTR: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SERIEENTR */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SERIEENTR utilizando a tabela Geral de Logs de Operaes */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_SERIEENTR' AND
                 TYPE   = 'TR'                AND
	              U.UID  = O.UID               AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_SERIEENTR
GO

CREATE TRIGGER LOG_GER_SERIEENTR
ON SERIEENTR
FOR INSERT, UPDATE, DELETE
AS
   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_DTOPER       DATETIME;
/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO       VARCHAR(1);

   DECLARE  @V_OLD_CDSERIEENTR     VARCHAR(5);
   DECLARE  @V_OLD_DSSERIEENTR     VARCHAR(20);
   DECLARE  @V_OLD_CDSERIEENTRNFE  VARCHAR(5);
   DECLARE  @V_OLD_CDSERIEENTSCAN  VARCHAR(5);

   DECLARE  @V_NEW_CDSERIEENTR     VARCHAR(5);
   DECLARE  @V_NEW_DSSERIEENTR     VARCHAR(20);
   DECLARE  @V_NEW_CDSERIEENTRNFE  VARCHAR(5);
   DECLARE  @V_NEW_CDSERIEENTSCAN  VARCHAR(5);

   DECLARE  @V_DSREMOTEADDR        VARCHAR(15);
   DECLARE  @V_DSREMOTEHOST        VARCHAR(15);
   DECLARE  @V_DSSERVERRDM         VARCHAR(20);
   DECLARE  @V_DSSERVMETHOD        VARCHAR(30);
   DECLARE  @V_DSREMOTEOPER        VARCHAR(12);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                   @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                   @P_DSSERVERRDM = @V_DSSERVERRDM OUTPUT,
                   @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                   @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   EXEC NMUSUARIO @P_NMUSUARIO = @V_USUARIO OUTPUT;

   SET  @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
      'D' IDCOMANDO,
      CDSERIEENTR,
      DSSERIEENTR,
      CDSERIEENTRNFE,
      CDSERIEENTSCAN,
      NULL,
      NULL,
      NULL,
      NULL
   FROM
      DELETED
   WHERE
      CDSERIEENTR NOT IN (SELECT CDSERIEENTR FROM INSERTED)
   UNION ALL

   SELECT
      'U' IDCOMANDO,
      DELETED.CDSERIEENTR,
      DELETED.DSSERIEENTR,
      DELETED.CDSERIEENTRNFE,
      DELETED.CDSERIEENTSCAN,
      INSERTED.CDSERIEENTR,
      INSERTED.DSSERIEENTR,
      INSERTED.CDSERIEENTRNFE,
      INSERTED.CDSERIEENTSCAN
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDSERIEENTR = DELETED.CDSERIEENTR
   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      CDSERIEENTR,
      DSSERIEENTR,
      CDSERIEENTRNFE,
      CDSERIEENTSCAN
   FROM
      INSERTED
   WHERE
      CDSERIEENTR NOT IN (SELECT CDSERIEENTR FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDSERIEENTR,
                                 @V_OLD_DSSERIEENTR,
                                 @V_OLD_CDSERIEENTRNFE,
                                 @V_OLD_CDSERIEENTSCAN,
                                 @V_NEW_CDSERIEENTR,
                                 @V_NEW_DSSERIEENTR,
                                 @V_NEW_CDSERIEENTRNFE,
                                 @V_NEW_CDSERIEENTSCAN;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_CDSERIEENTR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod=' + @V_OLD_CDSERIEENTR;
         END;

         IF @V_OLD_DSSERIEENTR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Descr=' + @V_OLD_DSSERIEENTR;
         END;

         IF @V_OLD_CDSERIEENTRNFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SNFe=' + @V_OLD_CDSERIEENTRNFE;
         END;

         IF @V_OLD_CDSERIEENTSCAN IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SScan=' + @V_OLD_CDSERIEENTSCAN;
         END;

         SET @V_TIPO         = '3';
         SET @V_ITPESQ       = @V_OLD_CDSERIEENTR;
      END
      ELSE
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (ISNULL(@V_OLD_CDSERIEENTR, ' ')    <> ISNULL(@V_NEW_CDSERIEENTR, ' '))    OR
               (ISNULL(@V_OLD_DSSERIEENTR, ' ')    <> ISNULL(@V_NEW_DSSERIEENTR, ' '))    OR
               (ISNULL(@V_OLD_CDSERIEENTRNFE, ' ') <> ISNULL(@V_NEW_CDSERIEENTRNFE, ' ')) OR
               (ISNULL(@V_OLD_CDSERIEENTSCAN, ' ') <> ISNULL(@V_NEW_CDSERIEENTSCAN, ' ')) BEGIN

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_OLD_CDSERIEENTR;
            END;
         END
         ELSE  BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_CDSERIEENTR;
         END;

      IF @V_NEW_CDSERIEENTR IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + 'Cod=' + @V_NEW_CDSERIEENTR;
      END;

      IF @V_NEW_DSSERIEENTR IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' Descr=' + @V_NEW_DSSERIEENTR;
      END;

      IF @V_NEW_CDSERIEENTRNFE IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' SNFe=' + @V_NEW_CDSERIEENTRNFE;
      END;

      IF @V_NEW_CDSERIEENTSCAN IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' SScan=' + @V_NEW_CDSERIEENTSCAN;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('SERIEENTR',  @V_DTOPER, @V_USUARIO,
                @V_TIPO,      @V_ITPESQ, @V_DESC,
                @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST,
                @V_DSSERVMETHOD, @V_DSREMOTEOPER);
            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_OLD_CDSERIEENTR,
                                    @V_OLD_DSSERIEENTR,
                                    @V_OLD_CDSERIEENTRNFE,
                                    @V_OLD_CDSERIEENTSCAN,
                                    @V_NEW_CDSERIEENTR,
                                    @V_NEW_DSSERIEENTR,
                                    @V_NEW_CDSERIEENTRNFE,
                                    @V_NEW_CDSERIEENTSCAN;
      END;
      CLOSE      C_CURSOR;
      DEALLOCATE C_CURSOR;
   END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_SERIEENTR','5.30.xxx';
GO
